<template>
  <div class="row">
    <div class="col-md-12">
      <edit-customer-form :model="model">
      </edit-customer-form>
    </div>
  </div>
</template>
<script>

  import EditCustomerForm from './Profile/EditCustomerForm';
  import CustomerDataService from '../services/CustomerDataService';
  import moment from 'moment';

  export default {
    components: {
      EditCustomerForm,
    },
    data() {
      return {
        model: {
          id: null,
          name: null,
          document: null,
          phone: null,
          contractNumber: null,
          contractValue: null,
          contractStatus: '',
          contractDate: null,
          action: '',
        },
      }
    },
    methods: {
      getCustomerInformations(id) {
        CustomerDataService.get(id)
          .then(response => {
            let data = response.data;

            if(data.contractDate) {
              data.contractDate = moment(String(data.contractDate)).format('MM/DD/YYYY')
            }

            if(data.document) {
              data.document = this.formataCPF(data.document);
            }

            this.model = data;
          })
          .catch(error => { 
            if(error.response.status === 400) {
              this.$notify({
                verticalAlign: 'top', 
                horizontalAlign: 'center', 
                message: 'Oops! O cliente não foi encontado.',
                type: 'danger'
              })
            } else {
              this.$notify({
                verticalAlign: 'top', 
                horizontalAlign: 'center', 
                message: 'Oops! Ocorreu um erro inesperado.',
                type: 'danger'
              })
            }

            this.$router.push({ path: '/table-list'})
          })
      },
      formataCPF(cpf){
        cpf = cpf.replace(/[^\d]/g, "");
        
        return cpf.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
      }
    },
    mounted() {
      if(this.$route.params.id) {
        this.getCustomerInformations(this.$route.params.id)
      }
    }
  }
</script>
<style>
</style>
